;************** ""  ******************************
;*
;* - MT10S1
;*  Atmega8
;*   - 8,00 
;*   T2 - 32768 
;*   ADC - 250000 
;* :
;* InitLCD:         4-  
;* CountTime:       T2
;* MAIN:         
;* Read_ADC:        
;* Set_of_par:   ()  
;* Set_of_parT:  ()  
;* WrEEPROM:       
;* WrEEPROM2:      
;* CycleH_H:           
;* CycleM_H:         .   
;* CycleM_M:           
;* CycleM_S:         .   .
;* CycleS_S:           
;* TimerH_M_S:   
;* Time_to_Display:    
;* Time_to_Display2:   
;* DIV42:   		   
;* Parameter_to_Display:    
;* Parameter_to_Display2:   
;* Waiting:    
;* EEWrite:	    "  EEPROM"
;* EERead:	    " EEPROM"
;* Sound:       
;***************************************************************************
.nolist
.include "m8def.inc"
.list
;*****  

.def  m0 = r0       ;  /   
.def  m1 = r1
.def  m2 = r2
.def  m3 = r3
.def  m4 = r4
.def  m5 = r5
.def  m6 = r6
.def  m7 = r7
.def  Sek2 = r8     ;     2
.def  Min= r9       ;   
.def  Hour = r10	;   
.def  hexH = r11	;  
.def  Min2= r13     ;    2              
.def  EEdwr =r14 	;      EEPROM
.def  EEdrd= r15 	;      EEPROM
.def  time = r16	;  
.;def  = r17    ; 
.def  CntS= r18		;    
.def  tmp1 = r19	;   1
.def  tmp2 = r20	;   2
.def  prm1 = r21	;  
.def  Cnt = r22	    ;  
.def  BCD0  = r23	;    - 
.def  CountZ  = r24	;  
.def  Sek = r25		;   

;***** *****

.equ  RS   = 1	    ; Register Select =  1  C
.equ  RW   = 2	    ; R/W =  2  C (/WR)
.equ  Ena  = 3	    ; Enable Impuls =  3  C
.equ  BF   = 3	    ;  ,  3
.equ  ADSM = 0b11001101   ; ADEN,ADSC,ADIE,ADPS2=1,ADPS1=0,ADPS0=1
.equ  ADMX1 = 0b11000000  ; REFS1=0,REFS0=0,Vref=2,56V,ADC0- PC0

.cseg

.org 0
rjmp  Initial	;      

.org 4
rjmp CountTime  ;     Timer2, 

.org  ADCCaddr           ;    ADC Complete
ldi   tmp1,0b00010000      ; SE=0 ( "" ), SM[2..0]=001
out   MCUCR,tmp1           ; ""  =  
reti

Initial:

ldi   tmp1,High(RamEnd)  ;  
out   sph,tmp1
ldi   tmp1,Low(RamEnd)
out   spl,tmp1	   
ldi   tmp1,0b00110000 ;  PC0-PC3   	       
out   PortC,tmp1   
ldi   tmp1,0b00111110	   
out   DDRC,tmp1	
       
ldi   tmp1,0b11111111 ;  D  
out   PortD,tmp1    
ldi   tmp1,0b00000100 
out   DDRD,tmp1
	    
ldi   tmp1,0b00110000 ;  B  
out   PortB,tmp1   
ldi   tmp1,0b00001111
out   DDRB,tmp1

ldi  tmp1,(1<<CS02)|(1<<CS00);  T/C0,  . = 1024
out  TCCR0,tmp1

ldi   tmp1,(1<<ACD)
	out   ACSR,tmp1       ;  

ldi tmp1,(1<<AS2)
out ASSR,tmp1     	 ;  T2    
ldi tmp1,0
out TCCR2,tmp1       ;  T2 
ser tmp1
out TIFR,tmp1        ;    
ldi tmp1,(1<<TOIE2)
out TIMSK,tmp1       ;   
;ldi tmp1,(1<<CS22)+(1<<CS20)
;out TCCR2,tmp1       ;  T/C2,  . = 128

ldi CntS,2			;      
            
ldi tmp1,1			;   
rcall EERead		; 
sts SDe,EEdrd		;   
ldi tmp1,2			;   
rcall EERead		; 
sts SDp,EEdrd		;   
ldi tmp1,3			;   
rcall EERead		; 
sts SDz,EEdrd		;   
ldi tmp1,4			;   
rcall EERead		; 
sts SDh,EEdrd		;   
ldi tmp1,5			;   
rcall EERead		; 
sts SDm,EEdrd		;   
ldi tmp1,6			;   
rcall EERead		; 
sts SDc,EEdrd		;   

rcall InitLCD      ;  -
sei                ;   
rjmp Main

;***********************************************************************************
;   4-  ,   .
;***********************************************************************************
SendCom:	;   - 
cbi   PortC,RS	; Register Select = 
rcall DataCD
ret

SendDat:	;   -  
sbi   PortC,RS	; Register Select =  
rcall DataCD
ret

DataCD:	;   = 4 
out   PortB,prm1	;  /   B
sbi   PortC,Ena	;   
nop
nop
nop
nop    	    ;     450 
cbi   PortC,Ena	;   
ret

WaitBusy:	;   -  
ldi   tmp1,0b00000000
out   DDRB,tmp1	;  B  
cbi   PortC,RS	; Register Select = 
sbi   PortC,RW	;  =   -
WB2:
sbi   PortC,Ena	;   ,  
nop
nop
nop	            ;  . 320   
in    tmp1,PinB	;  BF    
cbi   PortC,Ena	;   
nop
nop
sbi   PortC,Ena	;   ,  
nop
nop
nop	            ;  . 320   
cbi   PortC,Ena	;   
nop
sbrc  tmp1,BF	;   ,  -  (BF=0)
rjmp  WB2
cbi   PortC,RW	;   =  -
ldi   tmp1,0b00001111
out   DDRB,tmp1	;  B  
ret

;***********************************************************************************
;   .
;***********************************************************************************

Wait50us:	    ;    = 8 
ldi   time,130	;  
Wait51:
dec   time
brne  Wait51
ret

Wait5ms:	    ;    = 8 
ldi   tmp1,100	;  
Wait55:
rcall wait50us
dec   tmp1
brne  Wait55
ret

InitLCD: ;     4-  

rcall wait5ms
rcall wait5ms
rcall wait5ms	;   > 20    
rcall wait5ms
rcall wait5ms
ldi   prm1,$03	; $03:  , 4 
rcall SendCom	;    -
rcall wait50us	;   50 k
ldi   prm1,$03	; $03:  , 4 
rcall SendCom	;  
rcall wait50us	;   50k 
ldi   prm1,$03	; $03:  , 4  
rcall SendCom	;  
rcall wait50us	;   50 k
ldi   prm1,$02	; $02:  , 4  
rcall SendCom	;  
rcall wait50us	;   50 k

ldi   prm1,$02  ; $02:  
rcall SendCom	;    -
ldi   prm1,$08  ; $08:  
rcall SendCom	;    -
rcall WaitBusy	;   -  

ldi   prm1,$00	; $00:  
rcall SendCom	;  
ldi   prm1,$08	; $08:  
rcall SendCom	;  
rcall WaitBusy	;   -  

ldi   prm1,$00	; $00:  
rcall SendCom	;  
ldi   prm1,$01	; $01:  
rcall SendCom	;  
rcall WaitBusy	;   -  

ldi   prm1,$00	; $00:    
rcall SendCom	;  
ldi   prm1,$06	; $06:    
rcall SendCom	;  
rcall wait5ms
ret
;***********************************************************************************
CountTime:;     T2

dec Sek2 		;    1
dec Sek 		;    1
brne CtExit		;    0,   
lds Sek,SDs		;   
dec Min2		;    1
dec Min			;    1
brne CtExit		;    0,   
lds Min,SDmx	;   
dec Hour 		;    1
brne CtExit		;    0,   
CtExit:
dec CntS 		;    1
brne Ign  		;    0,   
cbi PORTD,2		;    
ldi CntS,2		;  
rjmp CtExit1	;   
Ign:
sbi PORTD,2		;     
CtExit1:
reti
;***********************************************************************************
Read_ADC: ;     

ldi   tmp1,ADMX1         ;     , Ra  
out   ADMUX,tmp1
ldi   tmp1,ADSM          ;      
out   ADCSR,tmp1
ldi  tmp1,(1<<SE)|(1<<SM0);  "" 
out  MCUCR,tmp1       
sleep                  ;   
in   m4,ADCL           ;   -
in   m5,ADCH           ;   -
ldi  tmp1,0b00001101   ;   
out  ADCSR,tmp1
rcall Divide10         ;   10
rcall HexBCD           ;   BCD-
ret
;***********************************************************************************
HexBCD:	        ; xx (Hex) -> 0abc (BCD)
rcall Div10	    ; hexH / 10, -  t1
mov   BCD0,tmp1	;   hexH, t1 =  1
rcall Div10
swap  tmp1        ;  2   
or    BCD0,tmp1   ;   2  1  BCD0
ret

Div10:	
clr  tmp1
lsl  hexH
rol  tmp1	        ;     10  
ldi  Cnt,7	    ;   7 
Loop10:
lsl  hexH	    ;     1 
rol  tmp1	        ;   t1
subi tmp1,10  	; ;  > 10 ?
brlo HB1	    ; ,  
inc  hexH       ;    1
rjmp HB2
HB1:
subi tmp1,-10	    ;   
HB2:
dec  Cnt	    ;   
brne Loop10	
ret

Divide10:  ;  -   10

mov tmp1,m4
andi tmp1,$FD     ; ""  
mov m4,tmp1
ldi tmp1,0
mov m1,tmp1       
mov m6,tmp1       ;  , 
mov m7,tmp1
ldi tmp1,10
mov m0,tmp1
rcall DIV42
mov hexH,m4    	  ;       BCD-
ret
;***********************************************************************************
Wait125:	        ;   125 
ldi   tmp1,0	    ;   
out   TCNT0,tmp1	;  T/C0
ldi   tmp1,1<<TOV0	;     TOV0
out   TIFR,tmp1	    ;   TOV0
ldi   time,4  	    ; 4   
Wait126:
in    tmp1,TIFR	    ;    TIFR
sbrs  tmp1,TOV0	    ;   ,   - 
rjmp  Wait126	        ;   
ldi   tmp1,1<<TOV0	;     TOV0
out   TIFR,tmp1	    ;   TOV0 
dec   time
brne  Wait126	    ; 4  = 125 
ret

Wait500:	        ;   500 
ldi   tmp1,0	    ;   
out   TCNT0,tmp1	;  T/C0
ldi   tmp1,1<<TOV0	;     TOV0
out   TIFR,tmp1	    ;   TOV0
ldi   time,16  	    ; 16   
Wait:
in    tmp1,TIFR	    ;    TIFR
sbrs  tmp1,TOV0	    ;   ,   - 
rjmp  Wait	        ;   
ldi   tmp1,1<<TOV0	;     TOV0
out   TIFR,tmp1	    ;   TOV0 
dec   time
brne  Wait	        ; 16  = 500 
ret
;***********************************************************************************
Main: ;  

clr tmp1
out TCCR2,tmp1      ;  T/C2 
rcall Waiting	    ; 
rcall Sound			; 
rcall Wait500		; 
sbi PORTD,2			;     
Main1:
sbis PIND,0         ;    SB0
rjmp Set_of_par 	;  () 
sbis PIND,3         ;    SB2
rjmp CycleH_H       ;   1,  -
sbis PIND,4         ;    SB3
rjmp CycleM_H       ;   2,  -
sbis PIND,5         ;    SB4
rjmp CycleM_M       ;   3,  -
sbis PIND,6         ;    SB5
rjmp CycleM_S       ;   4,  -
sbis PIND,7         ;    SB6
rjmp CycleS_S       ;   5,  -
sbis PINB,4         ;    SB1
rjmp Set_of_parT 	;  () 
sbis PINB,5			;    SB7
rcall TimerH_M_S 	;  
rjmp Main1
;***********************************************************************************
Set_of_par: ;  ()  

rcall Sound			; 
clr tmp1			;   
sts SD0,tmp1
sts SD1,tmp1
sts SD2,tmp1
sts SD3,tmp1
sts SD4,tmp1
sts SD5,tmp1
Set_of_par1:
rcall Wait500		; 
rcall Read_ADC 		;     
sts SDe,m4     		;   ,  
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts SD5,BCD0		;    
andi  tmp1,$0F   	; 
sts SD4,tmp1		;    
rcall Parameter_to_Display ;   
sbis PIND,0         ;    SB0
rjmp Set_par1
rjmp Set_of_par1
Set_par1:
rcall Sound			; 
Set_par2:
rcall Wait500		; 
rcall Read_ADC 		;     
sts SDp,m4     		;   ,  
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts SD3,BCD0		;    
andi  tmp1,$0F   	; 
sts SD2,tmp1		;    
rcall Parameter_to_Display ;   
sbis PIND,0         ;    SB0
rjmp Set_par3
rjmp Set_par2
Set_par3:
rcall Sound			; 
Set_par4:
rcall Wait500		; 
rcall Read_ADC 		;     
sts SDz,m4     		;   ,  
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts SD1,BCD0		;    
andi  tmp1,$0F   	; 
sts SD0,tmp1		;    
rcall Parameter_to_Display ;   
sbis PIND,0         ;    SB0
rjmp WrEEPROM 		;    
rjmp Set_par4
;***********************************************************************************
WrEEPROM: ;     

lds EEdwr,SDe	;    
ldi tmp1,1		;  
rcall EEWrite	;   
lds EEdwr,SDp	;    
ldi tmp1,2		;  
rcall EEWrite	;   
lds EEdwr,SDz	;    
ldi tmp1,3		;  
rcall EEWrite	;    
rjmp Main		;     
;***********************************************************************************
Sound2:;   

clr tmp1
out TCCR2,tmp1      ;  T/C2 
sbi PORTD,2			;     
rcall Timer_Stop ;     
rcall Sound
rcall Wait500
rcall Sound
rcall Wait500
rcall Sound
rcall Wait500
rcall Sound
rcall Wait500
rjmp Main		;    
;***********************************************************************************
Set_of_parT: ;  ()  

rcall Sound			; 
clr tmp1			;   
sts DS0,tmp1
sts DS1,tmp1
sts DS2,tmp1
sts DS3,tmp1
sts DS4,tmp1
sts DS5,tmp1
Set_of_par4:
rcall Wait500		; 
rcall Read_ADC 		;     
sts SDh,m4     		;   ,  
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts DS5,BCD0		;    
andi  tmp1,$0F   	; 
sts DS4,tmp1		;    
rcall Parameter_to_Display2 ;   
sbis PINB,4         ;    SB1
rjmp Set_par5
rjmp Set_of_par4
Set_par5:
rcall Sound			; 
Set_par6:
rcall Wait500		; 
rcall Read_ADC 		;     
sts SDm,m4     		;   ,  
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts DS3,BCD0		;    
andi  tmp1,$0F   	; 
sts DS2,tmp1		;    
rcall Parameter_to_Display2 ;   
sbis PINB,4         ;    SB1
rjmp Set_par7
rjmp Set_par6
Set_par7:
rcall Sound			; 
Set_par8:
rcall Wait500		; 
rcall Read_ADC 		;     
sts SDc,m4     		;   ,  
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts DS1,BCD0		;    
andi  tmp1,$0F   	; 
sts DS0,tmp1		;    
rcall Parameter_to_Display2 ;   
sbis PINB,4         ;    SB1
rjmp WrEEPROM2 		;    
rjmp Set_par8
;***********************************************************************************
WrEEPROM2: ;     

lds EEdwr,SDh	;     
ldi tmp1,4		;  
rcall EEWrite	;   
lds EEdwr,SDm	;     
ldi tmp1,5		;  
rcall EEWrite	;   
lds EEdwr,SDc	;     
ldi tmp1,6		;  
rcall EEWrite	;    
rjmp Main		;     
;***********************************************************************************
CycleH_H: ;        

ldi tmp1,0
out TCNT2,tmp1       ;   T/C2
lds CountZ,SDz		;     
CycleH_H1:
ldi tmp1,$04
sts SD11,tmp1		;     ""
ldi tmp1,$02
sts SD10,tmp1		;     ""
ldi tmp1,$0C
sts SD7,tmp1		;     ""
ldi tmp1,$00
sts SD6,tmp1		;     ""
ldi tmp1,$06
sts SD5,tmp1		;     ""
ldi tmp1,$01
sts SD4,tmp1		;     ""
ldi tmp1,$06
sts SD3,tmp1		;     ""
ldi tmp1,$03
sts SD2,tmp1		;     ""
ldi Sek,60			 ;      60
sts SDs,Sek			 ;      60
mov Min,Sek 		 ;      60
sts SDmx,Sek		;   60   
lds Hour,SDe		 ;     
ldi tmp1,(1<<CS22)+(1<<CS20)
out TCCR2,tmp1       ;  T/C2,  . = 128
cbi PORTC,4		     ;   
CycleH0:
mov hexH,Hour		;     BCD 
rcall HexBCD        ;   BCD-
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts SD9,BCD0		;    
andi  tmp1,$0F   	; 
sts SD8,tmp1		;    
mov hexH,CountZ		;     BCD 
rcall HexBCD        ;   BCD-
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts SD1,BCD0		;    
andi  tmp1,$0F   	; 
sts SD0,tmp1		;    
rcall Time_to_Display ;   
tst Hour  			;     
breq Zero			; ,  0
rjmp CycleH0		;   
Zero:
sbi PORTC,4		     ;  
cpi CountZ,1		;   
breq Stop
ldi tmp1,$0A
sts SD11,tmp1		;     ""
ldi tmp1,$08
sts SD10,tmp1		;     ""
lds Hour,SDp		 ;      
;sbi PORTC,4		     ;  
CycleH1:
mov hexH,Hour		;     BCD 
rcall HexBCD        ;   BCD-
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts SD9,BCD0		;    
andi  tmp1,$0F   	; 
sts SD8,tmp1		;    
mov hexH,CountZ		;     BCD 
rcall HexBCD        ;   BCD-
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts SD1,BCD0		;    
andi  tmp1,$0F   	; 
sts SD0,tmp1		;    
rcall Time_to_Display ;   
tst Hour  			;     
breq Zero1			; ,  0
rjmp CycleH1		;   
Zero1:
sbis PIND,1			;   S1
rjmp CycleH_H1		;  
dec CountZ			;    1
brne Continue		;    0,   
Stop: 
rjmp Sound2			;   
Continue:
rjmp CycleH_H1		;  
;***********************************************************************************
CycleM_H: ;          

ldi tmp1,0
out TCNT2,tmp1       ;   T/C2
lds CountZ,SDz		;     
CycleM_H1:
clr tmp1
sts SDmx,tmp1		;   
ldi tmp1,$04
sts SD11,tmp1		;     ""
ldi tmp1,$02
sts SD10,tmp1		;     ""
ldi tmp1,$0B
sts SD7,tmp1		;     ""
ldi tmp1,$0C
sts SD6,tmp1		;     ""
ldi tmp1,$0B
sts SD5,tmp1		;     ""
ldi tmp1,$08
sts SD4,tmp1		;     ""
ldi tmp1,$0B
sts SD3,tmp1		;     ""
ldi tmp1,$0D
sts SD2,tmp1		;     ""
ldi Sek,60			 ;      60
sts SDs,Sek			 ;      60
lds Min,SDe		     ;     
ldi tmp1,(1<<CS22)+(1<<CS20)
out TCCR2,tmp1       ;  T/C2,  . = 128
cbi PORTC,4		     ;   
CycleM0:
mov hexH,Min		;     BCD 
rcall HexBCD        ;   BCD-
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts SD9,BCD0		;    
andi  tmp1,$0F   	; 
sts SD8,tmp1		;    
mov hexH,CountZ		;     BCD 
rcall HexBCD        ;   BCD-
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts SD1,BCD0		;    
andi  tmp1,$0F   	; 
sts SD0,tmp1		;    
rcall Time_to_Display ;   
tst Min  			;     
breq Zero2			; ,  0
rjmp CycleM0		;   
Zero2:
ldi tmp1,$0A
sts SD11,tmp1		;     ""
ldi tmp1,$08
sts SD10,tmp1		;     ""
ldi tmp1,$0C
sts SD7,tmp1		;     ""
ldi tmp1,$00
sts SD6,tmp1		;     ""
ldi tmp1,$06
sts SD5,tmp1		;     ""
ldi tmp1,$01
sts SD4,tmp1		;     ""
ldi tmp1,$06
sts SD3,tmp1		;     ""
ldi tmp1,$03
sts SD2,tmp1		;     ""
lds hexH,SDp		;   

sbi PORTC,4		     ;  
cpi CountZ,1		;   
breq Stop1

rcall HexBCD        ;   BCD-
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts SD1,BCD0		;    
andi  tmp1,$0F   	; 
sts SD0,tmp1		;    
ldi Sek,60			 ;      60
sts SDs,Sek			 ;      60
mov Min,Sek			;     60
sts SDmx,Sek		;   60   
lds Hour,SDp		 ;      
;sbi PORTC,4		     ;  
CycleM1:
mov hexH,Hour		;     BCD 
rcall HexBCD        ;   BCD-
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts SD9,BCD0		;    
andi  tmp1,$0F   	; 
sts SD8,tmp1		;    
mov hexH,CountZ		;     BCD 
rcall HexBCD        ;   BCD-
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts SD1,BCD0		;    
andi  tmp1,$0F   	; 
sts SD0,tmp1		;    
rcall Time_to_Display ;   
tst Hour  			;     
breq Zero3			; ,  0
rjmp CycleM1		;   
Zero3:
sbis PIND,1			;   S1
rjmp CycleM_H1		;  
dec CountZ			;    1
brne Continue1		;    0,   
Stop1: 
rjmp Sound2			;   
Continue1:
rjmp CycleM_H1		;  
;***********************************************************************************
CycleM_M: ;        

ldi tmp1,0
out TCNT2,tmp1       ;   T/C2
sts SDmx,tmp1		;   
lds CountZ,SDz		;     
CycleM_M1:
ldi tmp1,$04
sts SD11,tmp1		;     ""
ldi tmp1,$02
sts SD10,tmp1		;     ""
ldi tmp1,$0B
sts SD7,tmp1		;     ""
ldi tmp1,$0C
sts SD6,tmp1		;     ""
ldi tmp1,$0B
sts SD5,tmp1		;     ""
ldi tmp1,$08
sts SD4,tmp1		;     ""
ldi tmp1,$0B
sts SD3,tmp1		;     ""
ldi tmp1,$0D
sts SD2,tmp1		;     ""
ldi Sek,60		    ;      60
sts SDs,Sek			 ;      60
lds Min,SDe		     ;     
ldi tmp1,(1<<CS22)+(1<<CS20)
out TCCR2,tmp1       ;  T/C2,  . = 128
cbi PORTC,4		     ;   
CycleM2:
mov hexH,Min		;     BCD 
rcall HexBCD        ;   BCD-
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts SD9,BCD0		;    
andi  tmp1,$0F   	; 
sts SD8,tmp1		;    
mov hexH,CountZ		;     BCD 
rcall HexBCD        ;   BCD-
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts SD1,BCD0		;    
andi  tmp1,$0F   	; 
sts SD0,tmp1		;    
rcall Time_to_Display ;   
tst Min  			;     
breq Zero4			; ,  0
rjmp CycleM2		;   
Zero4:
sbi PORTC,4		     ;  
cpi CountZ,1		;   
breq Stop2
ldi tmp1,$0A
sts SD11,tmp1		;     ""
ldi tmp1,$08
sts SD10,tmp1		;     ""
lds Min,SDp		     ;     
;sbi PORTC,4		     ;  
CycleM3:
mov hexH,Min		;     BCD 
rcall HexBCD        ;   BCD-
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts SD9,BCD0		;    
andi  tmp1,$0F   	; 
sts SD8,tmp1		;    
mov hexH,CountZ		;     BCD 
rcall HexBCD        ;   BCD-
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts SD1,BCD0		;    
andi  tmp1,$0F   	; 
sts SD0,tmp1		;    
rcall Time_to_Display ;   
tst Min  			;     
breq Zero5			; ,  0
rjmp CycleM3		;   
Zero5:
sbis PIND,1			;   S1
rjmp CycleM_M1		;  
dec CountZ			;    1
brne Continue2		;    0,   
Stop2: 
rjmp Sound2			;   
Continue2:
rjmp CycleM_M1		;  
;***********************************************************************************
CycleM_S: ;         

ldi tmp1,0
out TCNT2,tmp1       ;   T/C2
sts SDmx,tmp1		;   
lds CountZ,SDz		;     
CycleM_S1:
ldi tmp1,$04
sts SD11,tmp1		;     ""
ldi tmp1,$02
sts SD10,tmp1		;     ""
ldi tmp1,$0B
sts SD7,tmp1		;     ""
ldi tmp1,$0C
sts SD6,tmp1		;     ""
ldi tmp1,$0B
sts SD5,tmp1		;     ""
ldi tmp1,$08
sts SD4,tmp1		;     ""
ldi tmp1,$0B
sts SD3,tmp1		;     ""
ldi tmp1,$0D
sts SD2,tmp1		;     ""
ldi Sek,60		    ;      60
sts SDs,Sek			 ;      60
lds Min,SDe		     ;     
ldi tmp1,(1<<CS22)+(1<<CS20)
out TCCR2,tmp1       ;  T/C2,  . = 128
cbi PORTC,4		     ;   
CycleM4:
mov hexH,Min		;     BCD 
rcall HexBCD        ;   BCD-
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts SD9,BCD0		;    
andi  tmp1,$0F   	; 
sts SD8,tmp1		;    
mov hexH,CountZ		;     BCD 
rcall HexBCD        ;   BCD-
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts SD1,BCD0		;    
andi  tmp1,$0F   	; 
sts SD0,tmp1		;    
rcall Time_to_Display ;   
tst Min  			;     
breq Zero6			; ,  0
rjmp CycleM4		;   
Zero6:
sbi PORTC,4		     ;  
cpi CountZ,1		;   
breq Stop3
ldi tmp1,$0A
sts SD11,tmp1		;     ""
ldi tmp1,$08
sts SD10,tmp1		;     ""
ldi tmp1,$06
sts SD7,tmp1		;     ""
ldi tmp1,$03
sts SD6,tmp1		;     ""
ldi tmp1,$06
sts SD5,tmp1		;     ""
ldi tmp1,$05
sts SD4,tmp1		;     ""
ldi tmp1,$0B
sts SD3,tmp1		;     ""
ldi tmp1,$0A
sts SD2,tmp1		;     ""
lds Sek2,SDp	     ;     
;sbi PORTC,4		     ;  
CycleM5:
mov hexH,Sek2		;     BCD 
rcall HexBCD        ;   BCD-
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts SD9,BCD0		;    
andi  tmp1,$0F   	; 
sts SD8,tmp1		;    
mov hexH,CountZ		;     BCD 
rcall HexBCD        ;   BCD-
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts SD1,BCD0		;    
andi  tmp1,$0F   	; 
sts SD0,tmp1		;    
rcall Time_to_Display ;   
tst Sek2  			;     
breq Zero7			; ,  0
rjmp CycleM5		;   
Zero7:
sbis PIND,1			;   S1
rjmp CycleM_S1		;  
dec CountZ			;    1
brne Continue3		;    0,    
Stop3:
rjmp Sound2			;   
Continue3:
rjmp CycleM_S1		;  
;***********************************************************************************
CycleS_S: ;        

ldi tmp1,0
out TCNT2,tmp1       ;   T/C2
lds CountZ,SDz		;     
CycleS_S1:
ldi tmp1,$04
sts SD11,tmp1		;     ""
ldi tmp1,$02
sts SD10,tmp1		;     ""
ldi tmp1,$06
sts SD7,tmp1		;     ""
ldi tmp1,$03
sts SD6,tmp1		;     ""
ldi tmp1,$06
sts SD5,tmp1		;     ""
ldi tmp1,$05
sts SD4,tmp1		;     ""
ldi tmp1,$0B
sts SD3,tmp1		;     ""
ldi tmp1,$0A
sts SD2,tmp1		;     ""
ldi Sek,60		    ;      60
sts SDs,Sek			 ;      60
lds Sek2,SDe		 ;     
ldi tmp1,(1<<CS22)+(1<<CS20)
out TCCR2,tmp1       ;  T/C2,  . = 128
cbi PORTC,4		     ;   
CycleS1:
mov hexH,Sek2		;     BCD 
rcall HexBCD        ;   BCD-
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts SD9,BCD0		;    
andi  tmp1,$0F   	; 
sts SD8,tmp1		;    
mov hexH,CountZ		;     BCD 
rcall HexBCD        ;   BCD-
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts SD1,BCD0		;    
andi  tmp1,$0F   	; 
sts SD0,tmp1		;    
rcall Time_to_Display ;   
tst Sek2  			;     
breq Zero8			; ,  0
rjmp CycleS1		;   
Zero8:
sbi PORTC,4		     ;  
cpi CountZ,1		;   
breq Stop4
ldi tmp1,$0A
sts SD11,tmp1		;     ""
ldi tmp1,$08
sts SD10,tmp1		;     ""
ldi tmp1,$06
sts SD7,tmp1		;     ""
ldi tmp1,$03
sts SD6,tmp1		;     ""
ldi tmp1,$06
sts SD5,tmp1		;     ""
ldi tmp1,$05
sts SD4,tmp1		;     ""
ldi tmp1,$0B
sts SD3,tmp1		;     ""
ldi tmp1,$0A
sts SD2,tmp1		;     ""
lds Sek2,SDp	     ;     
;sbi PORTC,4		     ;  
CycleS2:
mov hexH,Sek2		;     BCD 
rcall HexBCD        ;   BCD-
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts SD9,BCD0		;    
andi  tmp1,$0F   	; 
sts SD8,tmp1		;    
mov hexH,CountZ		;     BCD 
rcall HexBCD        ;   BCD-
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts SD1,BCD0		;    
andi  tmp1,$0F   	; 
sts SD0,tmp1		;    
rcall Time_to_Display ;   
tst Sek2  			;     
breq Zero9			; ,  0
rjmp CycleS2		;   
Zero9:
sbis PIND,1			;   S1
rjmp CycleS_S1		;  
dec CountZ			;    1
brne Continue4		;    0,    
Stop4:
rjmp Sound2			;   
Continue4:
rjmp CycleS_S1		;  
;***********************************************************************************
TimerH_M_S: ;  "" 

ldi tmp1,0
out TCNT2,tmp1       ;   T/C2
ldi Sek,60			 ;      60
ldi tmp1,60
mov Min,tmp1 		 ;      60
sts SDs,Sek			 ;      60
sts SDmx,Sek		 ;      60
lds Sek2,SDc		;    
lds Min2,SDm		;    
lds Hour,SDh		;    
ldi tmp1,(1<<CS22)+(1<<CS20)
out TCCR2,tmp1      ;  T/C2,  . = 128
cbi PORTC,4		    ;  
TimerH_M_S1:
mov hexH,Hour		;     BCD 
rcall HexBCD
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts SD5,BCD0		;    
andi  tmp1,$0F   	; 
sts SD4,tmp1		;    
lds hexH,SDm		;     BCD 
rcall HexBCD        ;   BCD-
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts SD3,BCD0		;    
andi  tmp1,$0F   	; 
sts SD2,tmp1		;    
lds hexH,SDc		;     BCD 
rcall HexBCD        ;   BCD-
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts SD1,BCD0		;    
andi  tmp1,$0F   	; 
sts SD0,tmp1		;    
rcall Time_to_Display2 ;   
tst Hour  			;     
breq ZeroH			; ,  0
rjmp TimerH_M_S1
ZeroH:
lds Min2,SDm		;    
mov hexH,Hour		;     BCD 
ZeroH1:
rcall HexBCD
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts SD5,BCD0		;    
andi  tmp1,$0F   	; 
sts SD4,tmp1		;    
mov hexH,Min2		;     BCD 
rcall HexBCD        ;   BCD-
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts SD3,BCD0		;    
andi  tmp1,$0F   	; 
sts SD2,tmp1		;    
lds hexH,SDc		;     BCD 
rcall HexBCD        ;   BCD-
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts SD1,BCD0		;    
andi  tmp1,$0F   	; 
sts SD0,tmp1		;    
rcall Time_to_Display2 ;   
tst Min2  			;     
breq ZeroM			; ,  0
rjmp ZeroH1
ZeroM:
lds Sek2,SDc		;    
mov hexH,Min2		;     BCD 
ZeroM1:
rcall HexBCD        ;   BCD-
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts SD3,BCD0		;    
andi  tmp1,$0F   	; 
sts SD2,tmp1		;    
mov hexH,Sek2		;     BCD 
rcall HexBCD        ;   BCD-
mov tmp1,BCD0		;   
swap  BCD0       	;    
andi  BCD0,$0F   	; 
sts SD1,BCD0		;    
andi  tmp1,$0F   	; 
sts SD0,tmp1		;    
rcall Time_to_Display2 ;   
tst Sek2  			;     
breq ZeroS			; ,  0
rjmp ZeroM1
ZeroS:
sbi PORTC,4		    ;  
rjmp Sound2			;   
;***********************************************************************************
DIV42:   ;  
ldi  tmp1,0x10
DCLK42:           ;   m7:m6:m5:m4
                  ;   m1:m0
clc               ;   m5:m4
mov  tmp2,m4
rol  tmp2
mov  m4,tmp2
mov  tmp2,m5
rol  tmp2
mov  m5,tmp2
mov  tmp2,m6
rol  tmp2
mov  m6,tmp2
mov  tmp2,m7
rol  tmp2
mov  m7,tmp2
in   Cnt,SREG
push Cnt
PER1:
clc
mov  tmp2,m6
sbc  tmp2,m0
mov  m6,tmp2
mov  tmp2,m7
sbc  tmp2,m1
mov  m7,tmp2
brcs PER2
pop  Cnt
out  SREG,Cnt
PER3:
inc m4
rjmp PER4
PER2:
pop  Cnt
out  SREG,Cnt
brcs PER3
mov  tmp2,m6
add  tmp2,m0
mov  m6,tmp2
mov  tmp2,m7
adc  tmp2,m1
mov  m7,tmp2
PER4:
dec  tmp1
cpi  tmp1,0
brne DCLK42
ret
;***********************************************************************************
Time_to_Display: ;   

rcall WaitBusy	;   -  
ldi   prm1,$00	 ;  , .   
rcall SendCom	 ;  
ldi   prm1,$0C	 ;  , .   
rcall SendCom	 ;  
rcall WaitBusy	;   -  

ldi   prm1,$00	 ;  ,    
rcall SendCom	 ;  
ldi   prm1,$01	 ;  ,    
rcall SendCom	 ;  
rcall WaitBusy	;   -  

lds   prm1,SD11   ; 
rcall SendDat    ;  
lds   prm1,SD10    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$01   ;  ">"
rcall SendDat    ;  
ldi   prm1,$03    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$03   ; 
rcall SendDat    ;  
lds   prm1,SD9    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$03  ; 
rcall SendDat    ;  
lds   prm1,SD8    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

lds   prm1,SD7   ; 
rcall SendDat    ;  
lds   prm1,SD6    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

lds   prm1,SD5   ; 
rcall SendDat    ;  
lds   prm1,SD4    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

lds   prm1,SD3   ; 
rcall SendDat    ;  
lds   prm1,SD2    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$02   ;  "."
rcall SendDat    ;  
ldi   prm1,$0E   ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$0C   ;   9
rcall SendCom	 ;  
ldi   prm1,$00   ;   9
rcall SendCom	 ;  
rcall WaitBusy	;   -  

sbis PIND,1		;   S1
rjmp TDS
ldi   prm1,$03   ; 
rcall SendDat    ;  
lds   prm1,SD1   ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$03   ; 
rcall SendDat    ;  
lds   prm1,SD0   ;  
rcall SendDat    ;  
rcall Wait125    ;     
ret
TDS:
ldi CountZ,2	 ;   
ldi   prm1,$07   ;  "x"
rcall SendDat    ;  
ldi   prm1,$08   ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$07   ;  "x"
rcall SendDat    ;  
ldi   prm1,$08   ;  
rcall SendDat    ;  
rcall Wait125    ;     
ret
;***********************************************************************************
Time_to_Display2: ;   

rcall WaitBusy	;   -  
ldi   prm1,$00	 ;  , .   
rcall SendCom	 ;  
ldi   prm1,$0C	 ;  , .   
rcall SendCom	 ;  
rcall WaitBusy	;   -  

ldi   prm1,$00	 ;  ,    
rcall SendCom	 ;  
ldi   prm1,$01	 ;  ,    
rcall SendCom	 ;  
rcall WaitBusy	;   -  

ldi   prm1,$03   ; 
rcall SendDat    ;  
lds   prm1,SD5    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$03   ; 
rcall SendDat    ;  
lds   prm1,SD4    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$0C   ;  ""
rcall SendDat    ;  
ldi   prm1,$00    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$03  ; 
rcall SendDat    ;  
lds   prm1,SD3    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$03   ; 
rcall SendDat    ;  
lds   prm1,SD2    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$0B   ;  ""
rcall SendDat    ;  
ldi   prm1,$0C    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$05   ; 
rcall SendDat    ;  
ldi   prm1,$0F   ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$03   ; 
rcall SendDat    ;  
lds   prm1,SD1    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$0C   ;   9
rcall SendCom	 ;  
ldi   prm1,$00   ;   9
rcall SendCom	 ;  
rcall WaitBusy	;   -  

ldi   prm1,$03   ; 
rcall SendDat    ;  
lds   prm1,SD0   ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$06   ;  ""
rcall SendDat    ;  
ldi   prm1,$03   ;  
rcall SendDat    ;  
rcall Wait125    ;     
ret
;***********************************************************************************
Parameter_to_Display: ;   

rcall WaitBusy	;   -  
ldi   prm1,$00	 ;  , .   
rcall SendCom	 ;  
ldi   prm1,$0C	 ;  , .   
rcall SendCom	 ;  
rcall WaitBusy	;   -  

ldi   prm1,$00	 ;  ,    
rcall SendCom	 ;  
ldi   prm1,$01	 ;  ,    
rcall SendCom	 ;  
rcall WaitBusy	;   -  

ldi   prm1,$04   ;  ""
rcall SendDat    ;  
ldi   prm1,$02    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$03   ; 
rcall SendDat    ;  
lds   prm1,SD5    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$03   ; 
rcall SendDat    ;  
lds   prm1,SD4    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$0A  ;  ""
rcall SendDat    ;  
ldi   prm1,$08    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$03   ; 
rcall SendDat    ;  
lds   prm1,SD3    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$03   ; 
rcall SendDat    ;  
lds   prm1,SD2    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$02   ; 
rcall SendDat    ;  
ldi   prm1,$00    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$0E   ;  ""
rcall SendDat    ;  
ldi   prm1,$01   ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$0C   ;   9
rcall SendCom	 ;  
ldi   prm1,$00   ;   9
rcall SendCom	 ;  
rcall WaitBusy	;   -  

ldi   prm1,$03   ; 
rcall SendDat    ;  
lds   prm1,SD1   ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$03   ; 
rcall SendDat    ;  
lds   prm1,SD0   ;  
rcall SendDat    ;  
ret
;***********************************************************************************
Parameter_to_Display2: ;   

rcall WaitBusy	;   -  
ldi   prm1,$00	 ;  , .   
rcall SendCom	 ;  
ldi   prm1,$0C	 ;  , .   
rcall SendCom	 ;  
rcall WaitBusy	;   -  

ldi   prm1,$00	 ;  ,    
rcall SendCom	 ;  
ldi   prm1,$01	 ;  ,    
rcall SendCom	 ;  
rcall WaitBusy	;   -  

ldi   prm1,$0A   ;  ""
rcall SendDat    ;  
ldi   prm1,$0B    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$03   ; 
rcall SendDat    ;  
lds   prm1,DS5    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$03   ; 
rcall SendDat    ;  
lds   prm1,DS4    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$04  ;  ""
rcall SendDat    ;  
ldi   prm1,$0D    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$03   ; 
rcall SendDat    ;  
lds   prm1,DS3    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$03   ; 
rcall SendDat    ;  
lds   prm1,DS2    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$02   ; 
rcall SendDat    ;  
ldi   prm1,$00    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$04   ;  ""
rcall SendDat    ;  
ldi   prm1,$03   ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$0C   ;   9
rcall SendCom	 ;  
ldi   prm1,$00   ;   9
rcall SendCom	 ;  
rcall WaitBusy	;   -  

ldi   prm1,$03   ; 
rcall SendDat    ;  
lds   prm1,DS1   ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$03   ; 
rcall SendDat    ;  
lds   prm1,DS0   ;  
rcall SendDat    ;  
ret
;***********************************************************************************
Timer_Stop: ;     

rcall WaitBusy	;   -  
ldi   prm1,$00	 ;  , .   
rcall SendCom	 ;  
ldi   prm1,$0C	 ;  , .   
rcall SendCom	 ;  
rcall WaitBusy	;   -  

ldi   prm1,$00	 ;  ,    
rcall SendCom	 ;  
ldi   prm1,$01	 ;  ,    
rcall SendCom	 ;  
rcall WaitBusy	;   -  

ldi   prm1,$05   ;  "T"
rcall SendDat    ;  
ldi   prm1,$04    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$06   ;  "i"
rcall SendDat    ;  
ldi   prm1,$09    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$06   ;  "m"
rcall SendDat    ;  
ldi   prm1,$0D    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$06  ;  "e"
rcall SendDat    ;  
ldi   prm1,$05    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$07   ;  "r"
rcall SendDat    ;  
ldi   prm1,$02    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$02   ;  "blank"
rcall SendDat    ;  
ldi   prm1,$00    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$07   ;  "s"
rcall SendDat    ;  
ldi   prm1,$03    ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$07   ;  "t"
rcall SendDat    ;  
ldi   prm1,$04   ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$0C   ;   9
rcall SendCom	 ;  
ldi   prm1,$00   ;   9
rcall SendCom	 ;  
rcall WaitBusy	;   -  

ldi   prm1,$06   ;  "o"
rcall SendDat    ;  
ldi   prm1,$0F   ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$07   ;  "p"
rcall SendDat    ;  
ldi   prm1,$00   ;  
rcall SendDat    ;  
ret
;***********************************************************************************
EEWrite:	;  "  EEPROM"

    sbic	EECR,EEWE	;  EEWE  . 0, 
	rjmp	EEWrite		;    
    ldi tmp2,0            ;      EEPROM -
	out	EEARH,tmp2 	    ;     
		                ;      EEPROM -
	out	EEARL,tmp1 	    ;     
	out	EEDR,EEdwr	    ;   -    
	sbi	EECR,EEMWE	    ;  EEMWE  
	sbi	EECR,EEWE	    ;  EEWE :  
				        ;     4- ,  
			        	;     2 
    ret

EERead:		;  " EEPROM"

   	sbic	EECR, EEWE	;  EEWE  . 0, 
	rjmp	EERead		;    
    ldi tmp2,0            ;      EEPROM -
	out	EEARH,tmp2 	    ;     
	           	        ;     EEPROM -
	out	EEARL,tmp1	    ;      
	sbi	EECR, EERE	    ;   EERE    .
				        ;   4 ,  
				        ;   2 
	in	EEdrd, EEDR	    ;   
    ret	
;***********************************************************************************
Waiting: ; 

rcall WaitBusy	;   -  
ldi   prm1,$00	 ;  , .   
rcall SendCom	 ;  
ldi   prm1,$0C	 ;  , .   
rcall SendCom	 ;  
rcall WaitBusy	;   -  

ldi   prm1,$00	 ;  ,    
rcall SendCom	 ;  
ldi   prm1,$01	 ;  ,    
rcall SendCom	 ;  
rcall WaitBusy	;   -  

ldi   prm1,$02   ;  "."
rcall SendDat    ;  
ldi   prm1,$0A   ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$04   ;  ""
rcall SendDat    ;  
ldi   prm1,$0F   ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$0B   ;  ""
rcall SendDat    ;  
ldi   prm1,$06   ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$0B   ;  ""
rcall SendDat    ;  
ldi   prm1,$08   ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$0E   ;  ""
rcall SendDat    ;  
ldi   prm1,$03   ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$06   ;  ""
rcall SendDat    ;  
ldi   prm1,$01   ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$0B   ;  ""
rcall SendDat    ;  
ldi   prm1,$0D   ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$0B   ;  ""
rcall SendDat    ;  
ldi   prm1,$08   ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$0C   ;   9
rcall SendCom	 ;  
ldi   prm1,$00   ;   9
rcall SendCom	 ;  
rcall WaitBusy	;   -  

ldi   prm1,$06   ;  ""
rcall SendDat    ;  
ldi   prm1,$05   ;  
rcall SendDat    ;  
rcall WaitBusy	;   -  

ldi   prm1,$02   ;  "."
rcall SendDat    ;  
ldi   prm1,$0A   ;  
rcall SendDat    ;  
ret
;***********************************************************************************
Sound:  ;  

cbi PORTC,5
nop
ldi XH,50
SU1:
sbi DDRC,5          ;     1,  
rcall Wait05ms      ;   
cbi DDRC,5          ;     0,   
rcall Wait05ms      ;   
dec XH
brne SU1
sbi PORTC,5
ret 

Wait05ms:	    ;    = 8,0 
ldi  tmp2,10    ;  
Wait502:
rcall wait50us
dec   tmp2
brne  Wait502
ret
;***********************************************************************************
.dseg

SDp:.byte 1   ;      ""
SDe:.byte 1   ;      ""
SDs:.byte 1   ;   
SDz:.byte 1   ;    
SDmx:.byte 1  ;   60   TimerH_M_S
SD11:.byte 1  ;    ""  ""
SD10:.byte 1  ;    ""  ""
SD9:.byte 1   ;       ,  
SD8:.byte 1   ;       ,  
SD7:.byte 1   ;   
SD6:.byte 1   ;   
SD5:.byte 1   ;   
SD4:.byte 1   ;   
SD3:.byte 1   ;   
SD2:.byte 1   ;   
SD1:.byte 1   ;       ,  
SD0:.byte 1   ;        ,  
SDh:.byte 1   ;      TimerH_M_S
SDm:.byte 1   ;      TimerH_M_S
SDc:.byte 1   ;      TimerH_M_S
DS5:.byte 1   ;	    TimerH_M_S
DS4:.byte 1   ;
DS3:.byte 1   ;
DS2:.byte 1   ;
DS1:.byte 1   ;
DS0:.byte 1   ;
 
.Exit








 





